function Msg(value)

    reaper.ShowConsoleMsg(tostring(value) .. "\n")

end


function main()



  org_cur_pos =  reaper.GetCursorPosition(0)
  retval, grid, swingmodeIn, swingamtIn = reaper.GetSetProjectGrid( 0, false )
  bpm1, beat_per_measure = reaper.GetProjectTimeSignature2(0)
  item = reaper.GetSelectedMediaItem(0, 0)
  if not item then
     reaper.MB("Select Item", "Select an Item", 0)
     reaper.defer(function () end)
     return
  end

  
  take = reaper.GetMediaItemTake(item, 0)
  item_pos = reaper.GetMediaItemInfo_Value( item, "D_POSITION" )
  reaper.SetMediaItemTakeInfo_Value( take, "D_PLAYRATE", 2 )
  take_pcm_source = reaper.GetMediaItemTake_Source(take)
  media_length, length_is_QN = reaper.GetMediaSourceLength( take_pcm_source )
  measure_length = reaper.GetMediaItemInfo_Value( item, "C_BEATATTACHMODE", 1 )  
  retvals_inputs, retvals_csv = reaper.GetUserInputs("Set Original Tempo - Bar or Beat", 2, "Enter item tempo bpm ,Snap to bar or (grid) beat", ",bar") 
  bpm, bar_beat = retvals_csv:match("([^,]+),([^,]+)")
  
  
      

  if not retvals_inputs then
     reaper.MB("Cancelled", "Cancelled", 0)
     reaper.defer(function () end)
     return   
  end
  
  if bar_beat == "beat" then
     beat_set = (((grid * beat_per_measure)/ bpm) * 60)
     pos = 0
     reaper.SetTakeStretchMarker( take, -1, pos, srcposIn ) -- initial stretch marker
     while (pos < media_length) do
         pos = pos + beat_set
         reaper.SetTakeStretchMarker( take, -1, pos, srcposIn )
      
     end    
  end
  
  if bar_beat == "bar" then 
     bar_set = (((beat_per_measure)/ bpm) * 60)
     pos = 0
     reaper.SetTakeStretchMarker( take, -1, pos, srcposIn ) -- initial stretch marker
     while (pos < media_length) do
         pos = pos + bar_set
         reaper.SetTakeStretchMarker( take, -1, pos, srcposIn )
      
     end
  end

  
   
   item_pos = reaper.GetMediaItemInfo_Value( item, "D_POSITION" )
   reaper.SetEditCurPos( item_pos, 0, 0 )
 

   cur_pos =  reaper.GetCursorPosition(0)
   item = reaper.GetSelectedMediaItem(0, 0) 
   take = reaper.GetMediaItemTake(item, 0)
   reaper.SetMediaItemTakeInfo_Value( take, "D_PLAYRATE", 1 )   
   stretch_count = reaper.GetTakeNumStretchMarkers( take )
  for i = 0, stretch_count do    
   retval, pos, srcpos = reaper.GetTakeStretchMarker( take, i )
   if pos >= item_pos then idx = i break end
  end 
   
   cur_pos =  reaper.GetCursorPosition(0)
   item_length = reaper.GetMediaItemInfo_Value( item, "D_LENGTH" ) 
   reaper.SetEditCurPos( item_pos, 0, 0 )
   idx = 0
   
  while (idx < stretch_count) do
     idx = idx +1
     if bar_beat == "beat" then
       reaper.Main_OnCommand(40647, 0)  -- View: Move cursor right to grid division
     end
     if bar_beat == "bar" then
       reaper.Main_OnCommand(41040, 0)  -- Move edit cursor to start of next measure
     end
            
     cur_pos =  reaper.GetCursorPosition(0)
     reaper.SetTakeStretchMarker( take, idx, cur_pos - item_pos)
     reaper.SetEditCurPos( cur_pos, 0, 0 )
     item_length = reaper.GetMediaItemInfo_Value( item, "D_LENGTH" )
     cur_pos =  reaper.GetCursorPosition(0)
     if cur_pos == item_length then break end
     
     
     
  end

  retval, pos, srcpos = reaper.GetTakeStretchMarker( take, stretch_count -1 )
  reaper.SetMediaItemLength( item, pos, true )
  reaper.Main_OnCommand(41173, 0) -- Item navigation: Move cursor to start of items
    
   
   
  
end

reaper.PreventUIRefresh(1)

reaper.Undo_BeginBlock()

main()

reaper.UpdateArrange()
reaper.UpdateTimeline()

reaper.Undo_EndBlock( "ReaTrak set item bpm and fit to project tempo map", - 1 )

reaper.PreventUIRefresh(-1)

reaper.defer(function () end)
