-----DEBUG CONTROL--------------------------------------------------------------

debug_output = true -- true/false --display debug messages in the console

-----DISPLAY CONSOLE MESSAGE----------------------------------------------------

-- Display a message in the console for debugging, message can be a number variable
-- or a string but not mixed. No line feed character is added.
function Msg(value)
  --returns nothing

  if debug_output then --check if flag is set true (at the start of this script)
    reaper.ShowConsoleMsg(tostring(value) )
  end
end


local dm, _ = debug_mode
local function Msg(str)
  reaper.ShowConsoleMsg(tostring(str).."\n")
end



function main()
    
    local retvals_inputs, retvals_csv  = reaper.GetUserInputs("Tranpose MIDI", 2, "Choose semitones eg: 2 or -2 ,From note above keyswitches", "0,-1")
    transpose, ks_note = retvals_csv:match("([^,]+),([^,]+)")
    if not retvals_inputs then
      reaper.MB( "Action aborted", "Action", 0 ) 
      reaper.defer(function () end)
      return
    end

    start_time, end_time = reaper.GetSet_LoopTimeRange2(0, false, false, 0, 0, false)
    if start_time == end_time then
      reaper.MB( "Select track and time selection!", "Action aborted", 0 )
      reaper.defer(function () end)
      return
    end
    
    reaper.Main_OnCommand(40718, 0) --Item: Select all items on selected tracks in current time selection

    reaper.Main_OnCommand(40153, 0) --Item: Open in built-in MIDI editor (set default behavior in preferences)

   hwnd = reaper.MIDIEditor_GetActive()
   reaper.MIDIEditor_OnCommand( hwnd, 40214 ) --Edit: Unselect all+
   reaper.MIDIEditor_OnCommand( hwnd, 40877 ) --Edit: Select all notes starting in time selection
   
   
   
   item = reaper.GetSelectedMediaItem(0, 0)
   if item ~= nil then
     take = reaper.GetActiveTake(item)
     if take ~= nil then
       --reaper.MIDI_EnumSelNotes( take, noteidx )
       retval, notecntOut, ccevtcntOut, textsyxevtcntOut = reaper.MIDI_CountEvts(take)
       if retval ~= nil then
         for i = 1, notecntOut, 1 do
           retval, selectedOut, mutedOut, startppqposOut, endppqposOut, chanOut, pitchOut, velOut = reaper.MIDI_GetNote(take, i-1)
           if pitchOut >= tonumber(ks_note) and selectedOut == true then 
             
             reaper.MIDI_SetNote( take, i-1, false, _, _, _, _, pitchOut + transpose, velOut , true )
             
           end      
         end
       end
     end
   end
   

   reaper.MIDIEditor_OnCommand( hwnd, 40214 ) --Edit: Unselect all
   --reaper.MIDIEditor_OnCommand( hwnd, 2 ) --File: Close window

end

reaper.PreventUIRefresh(1)

reaper.Undo_BeginBlock()

main()

reaper.UpdateArrange()
reaper.UpdateTimeline()

reaper.Undo_EndBlock( "ReaTrak transpose midi item selection", - 1 )

reaper.PreventUIRefresh(-1)

reaper.defer(function () end)
